implicit real*8(a-h,o-z)
dimension x(100000),y(100000),z(100000),e66(6,6),b(3,3)&
&,mesh(300000,8)
!プログラムはメートル、MPa、
b1=0.1d0!幅(m)
b2=0.8d0!幅(m)
h1=0.1d0!高さ(m)
h2=0.8d0!高さ(m)
ell=3.0d0!長さ
p=1.0d0
!ヤング率
ezz=7.694d3
exx=ezz/25.0d0!x軸方向のヤング率
eyy=ezz/25.0d0!y軸方向のヤング率
ezz2=206.0d3!z軸方向のヤング率
!ポアソン比の入力
poixy=0.016d0
poixz=poixy
poiyx=poixy
poiyz=poixy
poizx=0.4d0
!せん断弾性係数の入力
gxy=ezz/15.0d0
gxz=gxy
gyz=gxy
!xyz方向の要素分割数
nx1=2
nx2=3
nx3=4
ny1=5
ny2=6
ny3=7
nz=100
!1つあたりの要素の長さ?
xn1=b1/nx1
xn2=b2/nx2
xn3=b1/nx3
yn1=h1/ny1
yn2=h2/ny2
yn3=h1/ny3
zn=ell/nz
! 節点番号ごとの節点座標!i~mで始まるのがdoで使える
!左下
nitimen=((nx1+nx2+nx3+1)*(ny1+ny3+2)+(nx1+nx3+2)*(ny2-1))
nitidan1=(nx1+nx2+nx3+1)

do k=0,nz!z
do j=0,ny1!
do i=0,nx1!x方向分割数を担当
nset=1+i+j*nitidan1+k*nitimen
x(nset)=i*xn1            
y(nset)=j*yn1            
z(nset)=k*zn             
end do                   
end do                 
end do

!真ん中下
do k=0,nz!z
do j=0,ny1!
do i=0,nx2-2!x方向分割数を担当
nset=nx1+2+i+j*nitidan1+k*nitimen
x(nset)=b1+(1+i)*xn2
y(nset)=j*yn1
z(nset)=k*zn
end do
end do
end do

!右下                                                 
do k=0,nz!z
do j=0,ny1!
do i=0,nx3!x方向分割数を担当
nset=nx1+nx2+1+i+j*nitidan1+k*nitimen
x(nset)=b1+b2+i*xn3            
y(nset)=j*yn1            
z(nset)=k*zn             
end do                   
end do                 
end do

!左
nitidan2=nx1+nx3+2

do k=0,nz!z
do j=0,ny2-2!
do i=0,nx1!x方向分割数を担当
nset=((nx1+nx2+nx3+1)*(ny1+1))+1+i+j*nitidan2+k*nitimen
x(nset)=i*xn1
y(nset)=h1+((1+j)*yn2)
z(nset)=k*zn
end do
end do
end do

!右
do k=0,nz!z
do j=0,ny2-2!
do i=0,nx3!x方向分割数を担当
nset=((nx1+nx2+nx3+1)*(ny1+1))+nx1+2+i+j*nitidan2+k*nitimen
x(nset)=b1+b2+i*xn3
y(nset)=h1+((1+j)*yn2)
z(nset)=k*zn
end do
end do
end do

!左上                                                            
do k=0,nz!z
do j=0,ny3!
do i=0,nx1!x方向分割数を担当
nset=nitidan1*(ny1+1)+nitidan2*(ny2-1)+1+i+j*nitidan1+k*nitimen
x(nset)=i*xn1            
y(nset)=h1+h2+j*yn3            
z(nset)=k*zn             
end do                   
end do                 
end do                  

!真ん中上          
do k=0,nz!z
do j=0,ny3!
do i=0,nx2-2!x方向分割数を担当
nset=nitidan1*(ny1+1)+nitidan2*(ny2-1)+nx1+2+i+j*nitidan1+k*nitimen
x(nset)=b1+(1+i)*xn2
y(nset)=h1+h2+j*yn3
z(nset)=k*zn
end do
end do
end do

!右上
do k=0,nz!z
do j=0,ny3!
do i=0,nx3!x方向分割数を担当
nset=nitidan1*(ny1+1)+nitidan2*(ny2-1)+nx1+nx2+1+i+j*nitidan1+k*nitimen
x(nset)=b1+b2+i*xn3
y(nset)=h1+h2+j*yn3
z(nset)=k*zn
end do
end do
end do
                                                                                
!i5~6が整数,aが文字,f9,6が小数.1peとかはEの＊乗
!接点番号と座標の出力
nsettenzenbu=nitimen*(nz+1)
print'("*NODE, NSET=Nall")'
do i=1,nsettenzenbu
print'(i6,a,f9.6,a,f9.6,a,f9.6)',&
    &i,',',x(i),',',y(i),',',z(i)
nsettensuu=i
end do

!要素番号とその要素の8接点の節点番号
!左下
nyou=0
do k=0,nz-1
do j=0,ny1
do i=1,nx1
nyou=nyou+1
mesh(nyou,1)=i+j*nitidan1+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan1
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan1
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!真ん中下
do k=0,nz-1
do j=0,ny1-1
do i=1,nx2
nyou=nyou+1
mesh(nyou,1)=nx1+i+j*nitidan1+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan1
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan1
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!右下
do k=0,nz-1
do j=0,ny1-1
do i=1,nx3
nyou=nyou+1
mesh(nyou,1)=nx1+nx2+i+j*nitidan1+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan1
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan1
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!左
do k=0,nz-1
do j=0,ny2-2
do i=1,nx1
nyou=nyou+1
mesh(nyou,1)=nitidan1*(ny1+1)+i+j*nitidan2+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan2
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan2
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!右
do k=0,nz-1
do j=0,ny2-2
do i=1,nx3
nyou=nyou+1
mesh(nyou,1)=nitidan1*ny1+nx1+nx2+i+j*nitidan2+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan2
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan2
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!左上
do k=0,nz-1
do j=0,ny3-1
do i=1,nx1
nyou=nyou+1
mesh(nyou,1)=nitidan1*(ny1+1)+nitidan2*(ny2-1)+i+j*nitidan1+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan1
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan1
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!真ん中上                                                
do k=0,nz-1
do j=0,ny3-1
do i=1,nx2
nyou=nyou+1
mesh(nyou,1)=nitidan1*(ny1+1)+nitidan2*(ny2-1)+nx1+i+j*nitidan1+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan1
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan1
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!右上
do k=0,nz-1
do j=0,ny3
do i=1,nx3
nyou=nyou+1
mesh(nyou,1)=nitidan1*(ny1+1)+nitidan2*(ny2-2)+nx1+1+i+j*nitidan1+k*nitimen
mesh(nyou,2)=mesh(nyou,1)+nitidan1
mesh(nyou,3)=mesh(nyou,2)+nitimen
mesh(nyou,4)=mesh(nyou,1)+nitimen
mesh(nyou,5)=mesh(nyou,1)+1
mesh(nyou,6)=mesh(nyou,5)+nitidan1
mesh(nyou,7)=mesh(nyou,6)+nitimen
mesh(nyou,8)=mesh(nyou,5)+nitimen
end do
end do
end do

!要素の出力
print'("*ELEMENT, TYPE=C3D8, ELSET=E1")'
do i=1,nyou
print'(i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6,a,i6)',&
    &i,',',&
    &mesh(i,1),',',&
    &mesh(i,2),',',&
    &mesh(i,3),',',&
    &mesh(i,4),',',&
    &mesh(i,5),',',&
    &mesh(i,6),',',&
    &mesh(i,7),',',&
    &mesh(i,8)
end do
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

print'("*END STEP")'
end
